# MetaSearch.py 
# (c) 2005 Charlie DeTar 
# This simple macro implements an in-page meta capable search.

import re, urllib
from MoinMoin import config, wikiutil, search

Dependencies = ["pages"]

def execute(macro, needle):
    request = macro.request

    # if no args given, do nothing.
    if needle is None or needle == '':
        return ""

    needle = needle.strip()

    QueryParser = wikiutil.importWikiPlugin(macro.cfg, 'action', 'metasearch', 'MetaCapableQueryParser')
    
    if not QueryParser:
        return "ERROR: MetaSearch macro depends on the metasearch.py action.  Please install metasearch.py action first."

    # Search the pages and return the results
    query = QueryParser().parse_query(needle)
    results = search.searchPages(request, query)                                    
    results.sortByPagename()

    return results.pageList(request, macro.formatter)
